]> git.ozlabs.org Git - yaboot.git/blob - ybin/ofpath
3724eb19a2b041200db003bccb721d7bc57f979c
[yaboot.git] / ybin / ofpath
1 #! /bin/sh
2
3 ###############################################################################
4 ##
5 ## ofpath: determine OpenFirmware path from unix device node
6 ## Copyright (C) 2000, 2001, 2002, 2003 Ethan Benson
7 ##
8 ## Portions based on show_of_path.sh:
9 ##
10 ## Copyright (C) 2000 Olaf Hering <olh@suse.de>
11 ##
12 ## This program is free software; you can redistribute it and/or
13 ## modify it under the terms of the GNU General Public License
14 ## as published by the Free Software Foundation; either version 2
15 ## of the License, or (at your option) any later version.
16 ##
17 ## This program is distributed in the hope that it will be useful,
18 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
19 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
20 ## GNU General Public License for more details.
21 ##
22 ## You should have received a copy of the GNU General Public License
23 ## along with this program; if not, write to the Free Software
24 ## Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
25 ##
26 ###############################################################################
27
28 PATH="/sbin:/bin:/usr/sbin:/usr/bin:/usr/local/sbin:/usr/local/bin"
29 PRG="${0##*/}"
30 VERSION=1.0.7
31 DEBUG=0
32 export LC_COLLATE=C
33
34 ## --version output.
35 version()
36 {
37 echo \
38 "$PRG $VERSION
39 Written by Ethan Benson
40 Portions based on show_of_path.sh written by Olaf Hering
41
42 Copyright (C) 2000, 2001, 2002, 2003 Ethan Benson
43 Portions Copyright (C) 2000 Olaf Hering
44 This is free software; see the source for copying conditions.  There is NO
45 warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE."
46 }
47
48 ## --help output.
49 usage()
50 {
51 echo \
52 "Usage: $PRG [OPTION]... FILE
53 Find OpenFirmware device path from unix device node.
54
55       --debug                print boring junk only useful for debugging
56   -h, --help                 display this help and exit
57   -V, --version              output version information and exit"
58 }
59
60 ## a small seq replacement, seq is not present on boot/rescue floppies.
61 smallseq()
62 {
63     local v="$1"
64     local n=1
65     echo 1
66     while [ "$v" -gt 1 ] ; do
67         echo "$(($n + 1))"
68         local n="$(($n + 1))"
69         local v="$(($v - 1))"
70     done
71     return 0
72 }
73
74 ## a kludge to replace wc -l, wc is not present on boot/rescue
75 ## floppies. max file is 145 lines, 3 hosts * 16 devs each * 3 lines
76 ## per device, + 1 "Attached Devices:" line.
77 linecount()
78 {
79     if [ $# = 0 ] ; then
80         local file="$(cat)"
81         local v="$file"
82     else
83         local file="$(cat $1)"
84         local v="$file"
85     fi
86
87     if [ -z "$file" ] ; then
88         echo 0
89         return 0
90     fi
91
92     ## use real wc if available
93     if (command -v wc > /dev/null 2>&1) ; then
94         if [ -x `command -v wc` ] ; then
95             lines="$(echo "$file" | wc -l)"
96             if [ $? = 0 ] ; then
97                 echo $lines
98                 unset lines
99                 return 0
100             fi
101         fi
102     fi
103
104     while true ; do
105         for i in `smallseq 145` ; do
106             local b="$(echo "$file" | tail -n $i)"
107             if [ "$v" = "$b" ] ; then
108                 echo "$i"
109                 break 2
110             fi
111         done
112     done
113     return 0
114 }
115
116 ## small tr replacment which handles a specific need of this script.
117 smalltr()
118 {
119     case "$1" in
120         a) echo 1 ;; b) echo 2 ;; c) echo 3 ;; d) echo 4 ;; e) echo 5 ;; f) echo 6 ;;
121         g) echo 7 ;; h) echo 8 ;; i) echo 9 ;; j) echo 10 ;; k) echo 11 ;; l) echo 12 ;;
122         m) echo 13 ;; n) echo 14 ;; o) echo 15 ;; p) echo 16 ;;
123         1) echo a ;; 2) echo b ;; 3) echo c ;; 4) echo d ;; 5) echo e ;;
124         6) echo f ;; 7) echo g ;; 8) echo h ;; 9) echo i ;; 10) echo j ;;
125         11) echo k ;; 12) echo l ;; 13) echo m ;; 14) echo n ;; 15) echo o ;;
126         16) echo p ;;
127     esac
128     return 0
129 }
130
131 ## replacment for grep -l which is not supported by busybox grep.
132 ## echo $(cat..) hack needed because busybox grep barfs with `line too
133 ## long' when fed /proc files.  the for loop is needed since busybox
134 ## grep seems to have somewhat broken regexp support.
135 ## usage: lgrep filename regexp regexp ...
136 lgrep()
137 {
138     local f="$1"
139     shift
140     for i in "$@" ; do
141         echo "$(cat "$f")" | grep -q "$i" && echo "$f" && break
142     done
143     return 0
144 }
145
146 ## if readlink is missing use a kludge
147 if (command -v readlink > /dev/null 2>&1) ; then
148     true
149 else
150     readlink()
151     {
152         local SYMTARGET="$(v=`ls -l "$1" 2>/dev/null` ; echo ${v##*> })"
153         if [ -n "$SYMTARGET" ] ; then
154             echo "$SYMTARGET"
155             return 0
156         else
157             return 1
158         fi
159     }
160 fi
161
162 ## a function to print relevant scsi host path when there is more then
163 ## one.  this function also takes care of stripping off the trailing
164 ## /compatible.
165 printhost()
166 {
167     case "$1" in
168         1)
169         echo "${2%/*}"
170         ;;
171         2)
172         echo "${3%/*}"
173         ;;
174         3)
175         echo "${4%/*}"
176         ;;
177         4)
178         echo "${5%/*}"
179         ;;
180     esac
181     return 0
182 }
183
184 ## this finds information we need on both newworld and oldworld macs.
185 ## mainly what scsi host a disk is attached to.
186 scsiinfo()
187 {
188     ## see if system has scsi at all
189     if [ ! -f /proc/scsi/scsi ] ; then
190         local kver="$(uname -r)"
191         case "$kver" in
192             2.5.*|2.6.*)
193                 if [ -d /sys/bus/scsi/devices -a \
194                     -n "$(ls /sys/bus/scsi/devices 2>/dev/null)" ] ; then
195                     echo 1>&2 "$PRG: /proc/scsi/scsi does not exist"
196                     echo 1>&2 "$PRG: Make sure you compiled your kernel with CONFIG_SCSI_PROC_FS=y"
197                     return 1
198                 fi
199                 ;;
200         esac
201         echo 1>&2 "$PRG: /dev/$DEVNODE: Device not configured"
202         return 1
203     fi
204
205     ## first we have to figure out the SCSI ID, have to do that
206     ## anyway [to] find the attached scsi disks = "Direct-Access" and
207     ## stop at sda=1 sdb=2 or whatever count in 3 lines steps
208
209     ## get last letter of device node, ie sda -> a
210     SUBNODE=${DEVNODE##*sd}
211
212     ## turn SUBNODE above into a number starting at 1, ie a -> 1
213     SUBDEV="$(smalltr $SUBNODE)"
214     [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: SUBNODE=$SUBNODE SUBDEV=$SUBDEV"
215
216     DEVCOUNT=0
217
218     ## copy scsi file into a variable removing "Attached Devices"
219     ## which is the first line. this avoids a lot of
220     ## [incmopatible] crap later, and improves readability.
221
222     ## find number of lines once and recycle that number, to save
223     ## some time (linecount is a bit slow). subtract one line
224     ## to scrap Attached Devices:
225
226     SCSILINES="$(($(linecount /proc/scsi/scsi) - 1))"
227
228     if [ "$SUBDEV" -gt "$(cat /proc/scsi/scsi | grep Direct-Access | linecount)" ] ; then
229         echo 1>&2 "$PRG: /dev/$DEVNODE: Device not configured"
230         return 1
231     fi
232
233     PROCSCSI="$(cat /proc/scsi/scsi | tail -n $SCSILINES)"
234
235     for i in $(smallseq $(($SCSILINES / 3))) ; do
236
237         ## put every scsi device into one single line
238         DEVINFO="$(echo "$PROCSCSI" | head -n $(($i * 3)) | tail -n 3)"
239         [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVINFO=$DEVINFO"
240
241         ## cut the type field, expect "Direct-Access" later.
242         DEVTYPE="$(v=$(echo ${DEVINFO##*Type: }) ; echo ${v%% *})"
243         [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVTYPE=$DEVTYPE"
244
245         ## get the device id.
246         DEVID="$(v=$(echo ${DEVINFO##*Id: }) ; n=$(echo ${v%% *}) ; echo ${n#*0})"
247         [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVID=$DEVID"
248
249         ## get the scsi host id.
250         DEVHOST="$(v=$(echo ${DEVINFO##*Host: scsi}) ; echo ${v%% *})"
251         [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVHOST=$DEVHOST"
252
253         if [ "$DEVTYPE" = "Direct-Access" ] ; then
254             DEVCOUNT="$(($DEVCOUNT + 1))"
255             [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVCOUNT=$DEVCOUNT"
256             if [ "$SUBDEV" = "$DEVCOUNT" ] ; then
257                 DEVICE_HOST=$DEVHOST
258                 DEVICE_ID=$DEVID
259                 [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVICE_HOST=$DEVICE_HOST"
260                 break
261             fi
262         fi
263     done
264
265     ## figure out what the scsi driver is, it is /proc/scsi/dirname.
266     [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVICE_HOST=$DEVICE_HOST"
267     SCSI_DRIVER="$(x=`ls /proc/scsi/*/$DEVICE_HOST 2>/dev/null | cat` ; y=`echo ${x##*proc/scsi/}` ; echo ${y%%/*})"
268     [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: SCSI_DRIVER=$SCSI_DRIVER"
269
270     ## figure out which host we found.
271     SCSI_HOSTNUMBER="$(v=`ls /proc/scsi/$SCSI_DRIVER/* 2>/dev/null | cat | grep -n "$DEVICE_HOST\>"` ; echo ${v%%:*})"
272     [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: SCSI_HOSTNUMBER=$SCSI_HOSTNUMBER"
273
274     return 0
275 }
276
277 ## generic function that can find OF device paths for scsi devices,
278 ## must be run after scsiinfo().
279 scsi_ofpath()
280 {
281     case "$SCSI_DRIVER" in
282         aic7xxx)
283             HOST_LIST="$(for i in `find /proc/device-tree -name compatible` ; do
284                         lgrep "$i" "^ADPT" "^pci900[45]" "^pciclass,01000" ; done)"
285             DEVICE_PATH="$(printhost $SCSI_HOSTNUMBER $HOST_LIST)"
286             echo "${DEVICE_PATH##*device-tree}/@$DEVICE_ID:$PARTITION"
287             ;;
288         sym53c8xx)
289             HOST_LIST="$(for i in `find /proc/device-tree -name compatible` ; do
290                         lgrep "$i" "^Symbios" "^pci1000" "^pciclass,01000" ; done)"
291             DEVICE_PATH="$(printhost $SCSI_HOSTNUMBER $HOST_LIST)"
292             echo "${DEVICE_PATH##*device-tree}/@$DEVICE_ID:$PARTITION"
293             ;;
294         mesh)
295             HOST_LIST="$(for i in `find /proc/device-tree -name compatible` ; do
296                         lgrep "$i" "mesh" ; done)"
297             DEVICE_PATH="$(printhost $SCSI_HOSTNUMBER $HOST_LIST)"
298             echo "${DEVICE_PATH##*device-tree}/@$DEVICE_ID:$PARTITION"
299             ;;
300         ata_k2|sata_svw)
301             HOST_LIST="$(for i in `find /proc/device-tree -name compatible ` ; do
302                         lgrep "$i" "k2-sata" ; done | sort)"
303             DEVICE_PATH="$(printhost $SCSI_HOSTNUMBER $HOST_LIST)"
304             echo "${DEVICE_PATH##*device-tree}/disk@0:$PARTITION"
305             ;;
306         sbp2)
307             HOST_LIST="$(for i in `find /proc/device-tree -name name` ; do
308                         lgrep "$i" "sbp-2" ; done)"
309             DEVICE_PATH="$(printhost $SCSI_HOSTNUMBER $HOST_LIST)"
310             echo "${DEVICE_PATH##*device-tree}/disk@0:$PARTITION"
311             ;;
312         *)
313             echo 1>&2 "$PRG: Driver: $SCSI_DRIVER is not supported"
314             return 1
315             ;;
316     esac
317     return 0
318 }
319
320 ide_ofpath()
321 {
322     if [ ! -L "/proc/ide/$DEVNODE" ] ; then
323         echo 1>&2 "$PRG: /dev/$DEVNODE: Device not configured"
324         return 1
325     fi
326
327     local IDEBUS="$(v=`readlink /proc/ide/$DEVNODE` ; echo ${v%%/*} )"
328     if [ -z "$IDEBUS" ] ; then
329         echo 1>&2 "$PRG: BUG: IDEBUS == NULL"
330         return 1
331     fi
332
333     case "$(uname -r)" in
334         2.5.*|2.6.0*|2.6.1|2.6.1-*|2.6.2|2.6.2-*)
335             echo 1>&2 "$PRG: Linux kernel `uname -r` is not supported"
336             return 1
337             ;;
338         2.6.*|2.7.*)
339             if ! (grep -q '.* .* sysfs ' /proc/mounts 2> /dev/null) ; then
340                 echo 1>&2 "$PRG: sysfs must be mounted for ofpath to support this system"
341                 return 1
342             fi
343             local SYS="$(m=`grep '.* .* sysfs ' /proc/mounts | head -n 1` ; echo `d=${m#* };echo ${d%% *}`)"
344             if [ -z "$SYS" -o ! -d "$SYS" ] ; then
345                 echo 1>&2 "$PRG: Unable to determine sysfs mountpoint"
346                 return 1
347             fi
348             local OF1275IDE="${SYS}/block/${DEVNODE}/device/../../devspec"
349             ;;
350         *)
351             local OF1275IDE="/proc/ide/$IDEBUS/devspec"
352             ;;
353     esac
354
355     if [ ! -f "$OF1275IDE" ] ; then
356         case "$(cat /proc/device-tree/model)" in
357             PowerMac3*|PowerMac4*|PowerMac5*|PowerMac6*|PowerMac7*|RackMac*)
358                 local CDROM="$(grep "^drive name:" /proc/sys/dev/cdrom/info 2> /dev/null | grep $DEVNODE)"
359                 if [ -z "$CDROM" ] ; then
360                     echo 1>&2 "$PRG: WARNING: Your kernel is too old for proper support, device may be innaccurate."
361                     echo "ultra2:$PARTITION"
362                 else
363                     echo "cd:$PARTITION"
364                 fi
365                 ;;
366             *)
367                 local CDROM="$(grep "^drive name:" /proc/sys/dev/cdrom/info 2> /dev/null | grep $DEVNODE)"
368                 if [ -z "$CDROM" ] ; then
369                     if [ "$DEVNODE" = hda ] ; then
370                         echo "hd:$PARTITION"
371                     else
372                         echo "ultra1:$PARTITION"
373                     fi
374                 else
375                     echo "cd:$PARTITION"
376                 fi
377                 ;;
378         esac
379     else
380         local DEVSPEC="$(cat $OF1275IDE)"
381         [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVSPEC=$DEVSPEC"
382         if [ -z "$DEVSPEC" ] ; then
383             echo 1>&2 "$PRG: KERNEL BUG: $OF1275IDE exists, but is empty"
384             return 1
385         fi
386
387         if [ ! -f "/proc/ide/${IDEBUS}/channel" ] ; then
388             echo 1>&2 "$PRG: KERNEL BUG: /proc/ide/${IDEBUS}/channel does not exist"
389             return 1
390         fi
391
392         case "$(cat /proc/device-tree${DEVSPEC}/device_type 2> /dev/null)" in
393             ide|ata)
394                 local MASTER="/disk@0"
395                 local SLAVE="/disk@1"
396                 ;;
397             pci-ide|pci-ata)
398                 local MASTER="/@$(cat /proc/ide/${IDEBUS}/channel)/disk@0"
399                 local SLAVE="/@$(cat /proc/ide/${IDEBUS}/channel)/disk@1"
400                 ;;
401             scsi) ## some lame controllers pretend they are scsi, hopefully all kludges are created equal.
402                 local MASTER="/@$(($(cat /proc/ide/${IDEBUS}/channel) * 2 + 0))"
403                 local SLAVE="/@$(($(cat /proc/ide/${IDEBUS}/channel) * 2 + 1))"
404                 ;;
405             spi)
406                 local MASTER="/disk@$(cat /proc/ide/${IDEBUS}/channel),0"
407                 local SLAVE="/disk@$(cat /proc/ide/${IDEBUS}/channel),1"
408                 ;;
409             *)
410                 echo 1>&2 "$PRG: Unsupported IDE device type: \"$(cat /proc/device-tree${DEVSPEC}/device_type 2> /dev/null)\""
411                 return 1
412                 ;;
413         esac
414
415         case "$DEVNODE" in
416             hda|hdc|hde|hdg|hdi|hdk|hdm|hdo)
417                 echo "${DEVSPEC}${MASTER}:$PARTITION"
418                 return 0
419                 ;;
420             hdb|hdd|hdf|hdh|hdj|hdl|hdn|hdp)
421                 echo "${DEVSPEC}${SLAVE}:$PARTITION"
422                 return 0
423                 ;;
424             *)
425                 echo 1>&2 "$PRG: /dev/$DEVNODE is not supported"
426                 return 1
427                 ;;
428         esac
429     fi
430 }
431
432 ## figure out the OpenFirmware device path for newworld macs.
433 ## sd* scsi disks , hd* ide disks.
434 newworld()
435 {
436     case "$DEVNODE" in
437         sd*)
438             ## use common scsiinfo function to get info we need.
439             scsiinfo || return 1
440
441             ## now we have the data for /@$DEVID:$PARTITION
442             ## find the actual OF path.
443             scsi_ofpath || return 1
444             ;;
445         hd*)
446             ide_ofpath || return 1
447             ;;
448         *)
449             echo 1>&2 "$PRG: Device: /dev/$DEVNODE is not supported"
450             return 1
451             ;;
452     esac
453     return 0
454 }
455
456 oldworld()
457 {
458     ## for some reason 2.4 kernels put OF aliases in aliases@0/ instead of plain aliases/
459     if [ -d "/proc/device-tree/aliases" ] ; then
460         local ALIASES="aliases"
461     elif [ -d "/proc/device-tree/aliases@0" ] ; then
462         local ALIASES="aliases@0"
463     else
464         echo 1>&2 "$PRG: Cannot find OpenFirmware aliases directory in /proc/device-tree/"
465         return 1
466     fi
467
468     local MODEL="$(cat /proc/device-tree/compatible)"
469     [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: Oldworld subarch: $MODEL"
470
471     case "$MODEL" in
472         AAPL,7300*|AAPL,7500*|AAPL,8500*|AAPL,9500*|AAPL,\?\?\?\?*)
473             case "$DEVNODE" in
474                 sd*)
475                 scsiinfo || return 1
476                 case "$SCSI_DRIVER" in
477                     mesh)
478                     echo $(cat /proc/device-tree/$ALIASES/scsi-int)/sd\@$DEVICE_ID:$PARTITION
479                     ;;
480                     53c94)
481                     echo $(cat /proc/device-tree/$ALIASES/scsi)/sd\@$DEVICE_ID:$PARTITION
482                     ;;
483                     *)
484                     echo 1>&2 "$PRG: Driver $SCSI_DRIVER is not supported"
485                     return 1
486                     ;;
487                 esac
488                 ;;
489                 *)
490                 echo 1>&2 "$PRG: Unsupported device: /dev/$DEVNODE"
491                 return 1
492                 ;;
493             esac
494             ;;
495         AAPL,e407*)
496             case "$DEVNODE" in
497                 sd*)
498                 scsiinfo || return 1
499                 case "$SCSI_DRIVER" in
500                     mesh)
501                     echo $(cat /proc/device-tree/$ALIASES/scsi)/sd\@$DEVICE_ID:$PARTITION
502                     ;;
503                     *)
504                     echo 1>&2 "$PRG: Driver $SCSI_DRIVER is not supported"
505                     return 1
506                     ;;
507                 esac
508                 ;;
509                 hda*)
510                 echo $(cat /proc/device-tree/$ALIASES/ata)/ATA-Disk\@0:$PARTITION
511                 ;;
512                 hdb*)
513                 echo $(cat /proc/device-tree/$ALIASES/ata)/ATA-Disk\@1:$PARTITION
514                 ;;
515                 hd*)
516                 echo 1>&2 "$PRG: Device: /dev/$DEVNODE is not supported"
517                 ;;
518             esac
519             ;;
520         AAPL,e826*)
521             case "$DEVNODE" in
522                 sd*)
523                 scsiinfo || return 1
524                 case "$SCSI_DRIVER" in
525                     mesh)
526                     echo $(cat /proc/device-tree/$ALIASES/scsi)/sd\@$DEVICE_ID:$PARTITION
527                     ;;
528                     *)
529                     echo 1>&2 "$PRG: Driver $SCSI_DRIVER is not supported"
530                     return 1
531                     ;;
532                 esac
533                 ;;
534                 hda*)
535                 echo $(cat /proc/device-tree/$ALIASES/ata)/ata-disk\@0:$PARTITION
536                 ;;
537                 hdb*)
538                 echo $(cat /proc/device-tree/$ALIASES/ata)/ata-disk\@1:$PARTITION
539                 ;;
540                 hd*)
541                 echo 1>&2 "$PRG: Device: /dev/$DEVNODE is not supported"
542                 ;;
543             esac
544             ;;
545         AAPL,Gossamer*|AAPL,PowerMac\ G3*)
546             case "$DEVNODE" in
547                 sd*)
548                 scsiinfo || return 1
549                 case "$SCSI_DRIVER" in
550                     mesh)
551                     echo $(cat /proc/device-tree/$ALIASES/scsi)/sd\@$DEVICE_ID:$PARTITION
552                     ;;
553                     *)
554                     echo 1>&2 "$PRG: Driver $SCSI_DRIVER is not supported"
555                     return 1
556                     ;;
557                 esac
558                 ;;
559                 hda*)
560                 echo $(cat /proc/device-tree/$ALIASES/ide0)/ata-disk\@0:$PARTITION
561                 ;;
562                 hdb*)
563                 echo $(cat /proc/device-tree/$ALIASES/ide0)/ata-disk\@1:$PARTITION
564                 ;;
565                 hdc*)
566                 echo $(cat /proc/device-tree/$ALIASES/ide1)/ata-disk\@0:$PARTITION
567                 ;;
568                 hdd*)
569                 echo $(cat /proc/device-tree/$ALIASES/ide1)/ata-disk\@1:$PARTITION
570                 ;;
571                 hd*)
572                 echo 1>&2 "$PRG: Device: /dev/$DEVNODE is not supported"
573                 ;;
574             esac
575             ;;
576         AAPL,PowerBook1998*)
577             if [ -f  /proc/device-tree/$ALIASES/ata0 ] ; then
578                 local ATA0=ata0
579             else
580                 local ATA0=ide0
581             fi
582             if [ -f  /proc/device-tree/$ALIASES/ata1 ] ; then
583                 local ATA1=ata1
584             else
585                 local ATA1=bay-ata1
586             fi
587             case "$DEVNODE" in
588                 sd*)
589                 scsiinfo || return 1
590                 case "$SCSI_DRIVER" in
591                     mesh)
592                     echo $(cat /proc/device-tree/$ALIASES/scsi)/sd\@$DEVICE_ID:$PARTITON
593                     ;;
594                     *)
595                     echo 1>&2 "$PRG: Driver $SCSI_DRIVER is not supported"
596                     return 1
597                     ;;
598                 esac
599                 ;;
600                 hda*)
601                 echo $(cat /proc/device-tree/$ALIASES/$ATA0)/ata-disk\@0:$PARTITION
602                 ;;
603                 hdb*)
604                 echo $(cat /proc/device-tree/$ALIASES/$ATA0)/ata-disk\@1:$PARTITION
605                 ;;
606                 hdc*)
607                 echo $(cat /proc/device-tree/$ALIASES/$ATA1)/atapi-disk\@0:$PARTITION
608                 ;;
609                 hdd*)
610                 echo $(cat /proc/device-tree/$ALIASES/$ATA1)/atapi-disk\@1:$PARTITION
611                 ;;
612                 *)
613                 echo 1>&2 "$PRG: Unsupported device: /dev/$DEVNODE"
614                 return 1
615                 ;;
616             esac
617             ;;
618         AAPL,3400/2400*)
619             case "$DEVNODE" in
620                 sd*)
621                 scsiinfo || return 1
622                 case "$SCSI_DRIVER" in
623                     mesh)
624                     echo $(cat /proc/device-tree/$ALIASES/scsi-int)/sd\@$DEVICE_ID:$PARTITON
625                     ;;
626                     53c94)
627                     echo $(cat /proc/device-tree/$ALIASES/scsi)/sd\@$DEVICE_ID:$PARTITON
628                     ;;
629                     *)
630                     echo 1>&2 "$PRG: Driver $SCSI_DRIVER is not supported"
631                     return 1
632                     ;;
633                 esac
634                 ;;
635                 hda*)
636                 echo $(cat /proc/device-tree/$ALIASES/ata0)/ata-disk\@0:$PARTITION
637                 ;;
638                 hdb*)
639                 echo $(cat /proc/device-tree/$ALIASES/ata0)/ata-disk\@1:$PARTITION
640                 ;;
641                 hdc*)
642                 echo $(cat /proc/device-tree/$ALIASES/ata1)/atapi-disk\@0:$PARTITION
643                 ;;
644                 hdd*)
645                 echo $(cat /proc/device-tree/$ALIASES/ata1)/atapi-disk\@1:$PARTITION
646                 ;;
647                 hde*)
648                 echo $(cat /proc/device-tree/$ALIASES/ata2):$PARTITION
649                 ;;
650                 hdf*)
651                 echo $(cat /proc/device-tree/$ALIASES/ata3):$PARTITION
652                 ;;
653                 *)
654                 echo 1>&2 "$PRG: Unsupported device: /dev/$DEVNODE"
655                 return 1
656                 ;;
657             esac
658             ;;
659         *)
660             echo 1>&2 "$PRG: This machine is not supported: $MODEL"
661             return 1
662             ;;
663     esac
664     return 0
665 }
666
667 ## find OpenFirmware device path for IBM CHRP hardware (scsi only)
668 chrp()
669 {
670     case "$DEVNODE" in
671         sd*)
672             if ls -l /proc/device-tree | grep -q ^d ; then
673                 true
674             else
675                 echo 1>&2 "$PRG: /proc/device-tree is broken."
676                 return 1
677             fi
678
679             ## use common scsiinfo function to get info we need.
680             scsiinfo || return 1
681
682             ## now we have the data for /@$DEVID:$PARTITION
683             ## find the actual OF path.
684             scsi_ofpath || return 1
685             ;;
686         *)
687             echo 1>&2 "$PRG: Device: /dev/$DEVNODE is not supported"
688             return 1
689             ;;
690     esac
691     return 0
692 }
693
694 ## If we get lame devfs name, we need to make it foad
695 ckdevfs()
696 {
697     case "$1" in
698         /dev/ide/*|/dev/scsi/*|/dev/discs/*)
699         return 0
700         ;;
701         *)
702         return 1
703         ;;
704     esac
705 }
706
707 ## convert devfs names into normal short ones, written by Tom Rini.
708 fixdevfs()
709 {
710     ## get partition number, if any
711     local PARTNUM="${1##*[a-z]}"
712     ## Find the bus type.
713     local TYPE="$(v=${1#/dev/} ; echo ${v%/host*})"
714     ## Find the host number.
715     local HOST="$(v=${1#/dev/*/host} ; echo ${v%/bus*})"
716     ## Find the bus number.
717     local BUS="$(v=${1#/dev/*/bus} ; echo ${v%/tar*})"
718     ## Find the target.
719     local TARGET="$(v=${1#/dev/*/target} ; echo ${v%/lun*})"
720
721     case "$TYPE" in
722         ide)
723         case "$HOST" in
724             0)
725             case "$TARGET" in
726                 0)
727                 local DEV=hda
728                 ;;
729                 1)
730                 local DEV=hdb
731                 ;;
732             esac
733             ;;
734             1)
735             case "$TARGET" in
736                 0)
737                 local DEV=hdc
738                 ;;
739                 1)
740                 local DEV=hdd
741                 ;;
742             esac
743             ;;
744             *)
745                 echo 1>&2 "$PRG: $1: Unable to translate this device, try again without devfs."
746                 return 1
747         esac
748         local DEV="${DEV}${PARTNUM}"
749         echo "/dev/$DEV"
750         return 0
751         ;;
752         scsi)
753         local LUN="$(v=${1#/dev/*/lun} ; echo ${v%/*})"
754
755         ## In this case, we need to figure out what number our device is
756         local DEVCOUNT=0
757
758         ## copy scsi file into a variable removing "Attached Devices"
759         ## which is the first line. this avoids a lot of
760         ## [incmopatible] crap later, and improves readability.
761
762         ## find number of lines once and recycle that number, to save
763         ## some time (linecount is a bit slow). subtract one line
764         ## to scrap Attached Devices:
765
766         local SCSILINES="$(($(linecount /proc/scsi/scsi) - 1))"
767         local PROCSCSI="$(cat /proc/scsi/scsi | tail -n $SCSILINES)"
768
769         for i in $(smallseq $(($SCSILINES / 3))) ; do
770
771             ## put every scsi device into one single line
772             local DEVINFO="$(echo "$PROCSCSI" | head -n $(($i * 3)) | tail -n 3)"
773             [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: fixdevfs: DEVINFO=$DEVINFO"
774
775             ## cut the type field, expect "Direct-Access" later.
776             local DEVTYPE="$(v=$(echo ${DEVINFO##*Type: }) ; echo ${v%% *})"
777             [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: fixdevfs: DEVTYPE=$DEVTYPE"
778
779             if [ "$DEVTYPE" = "Direct-Access" ] ; then
780                 ## Lets find out some more information
781                 ## get the device id.
782                 local DEVID="$(v=$(echo ${DEVINFO##*Id: }) ; n=$(echo ${v%% *}) ; echo ${n#*0})"
783                 [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: fixdevfs: DEVID=$DEVID"
784
785                 ## get the device lun.
786                 local DEVLUN="$(v=$(echo ${DEVINFO##*Lun: }) ; n=$(echo ${v%% *}) ; echo ${n#*0})"
787                 [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: fixdevfs: DEVLUN=$DEVLUN"
788
789                 ## get the device channel.
790                 local DEVCHAN="$(v=$(echo ${DEVINFO##*Channel: }) ; n=$(echo ${v%% *}) ; echo ${n#*0})"
791                 [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: fixdevfs: DEVCHAN=$DEVCHAN"
792
793                 ## get the scsi host id.
794                 local DEVHOST="$(v=$(echo ${DEVINFO##*Host: scsi}) ; echo ${v%% *})"
795                 [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: fixdevfs: DEVHOST=$DEVHOST"
796
797                 local DEVCOUNT="$(($DEVCOUNT + 1))"
798                 [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: fixdevfs: DEVCOUNT=$DEVCOUNT"
799                 if [ "$DEVHOST" = "$HOST" -a "$DEVCHAN" = "$BUS" -a \
800                     "$DEVID" = "$TARGET" -a "$DEVLUN" = "$LUN" ] ; then
801                     local DEV="sd$(smalltr $DEVCOUNT)${PARTNUM}"
802                     echo "/dev/$DEV"
803                     return 0
804                 fi
805             fi
806         done
807         echo 1>&2 "$PRG: $1: Unable to translate this device, try again without devfs."
808         return 1
809         ;;
810         *)
811         echo 1>&2 "$PRG: Unknown bus $TYPE"
812         return 1
813         ;;
814     esac
815     ## we should never get here
816     return 1
817 }
818
819 ## make sure that find, head and tail can be found.  otherwise the
820 ## script will silently give bogus paths.  these are the only /usr/*
821 ## utilities this script depends on.
822 checkutils()
823 {
824     if command -v find > /dev/null 2>&1 ; then
825         [ -x `command -v find` ] || FAIL=1 ; else FAIL=1 ; fi
826     if command -v head > /dev/null 2>&1 ; then
827         [ -x `command -v head` ] || FAIL=1 ; else FAIL=1 ; fi
828     if command -v tail > /dev/null 2>&1 ; then
829         [ -x `command -v tail` ] || FAIL=1 ; else FAIL=1 ; fi
830
831     if [ "$FAIL" = 1 ] ; then
832         echo 1>&2 "$PRG: \`find', \`head', or \`tail' could not be found, aborting."
833         return 1
834     else
835         return 0
836     fi
837 }
838
839 ## parse command line switches.
840 if [ $# != 0 ] ; then
841     while true ; do
842         case "$1" in
843             -V|--version)
844                 version
845                 exit 0
846                 ;;
847             -h|--help)
848                 usage
849                 exit 0
850                 ;;
851             --debug)
852                 DEBUG=1
853                 shift
854                 ;;
855             -*)
856                 echo 1>&2 "$PRG: unrecognized option \`$1'"
857                 echo 1>&2 "$PRG: Try \`$PRG --help' for more information."
858                 exit 1
859                 ;;
860             "")
861                 echo 1>&2 "$PRG: You must specify a filename"
862                 echo 1>&2 "Try \`$PRG --help' for more information."
863                 exit 1
864                 ;;
865             *)
866                 device="$1"
867                 break
868                 ;;
869         esac
870     done
871 else
872     echo 1>&2 "$PRG: You must specify a /dev device"
873     echo 1>&2 "Try \`$PRG --help' for more information."
874     exit 1
875 fi
876
877 ## check that FILE is a block device and exists.
878 if [ ! -e "$device" ] ; then
879     echo 1>&2 "$PRG: $device: No such file or directory"
880     exit 1
881 elif [ ! -b "$device" ] ; then
882     echo 1>&2 "$PRG: $device is not a block device"
883     exit 1
884 fi
885
886 ## check that we are running on a GNU/Linux system, OSX/BSD does not
887 ## have the same /proc stuff
888 if [ `uname -s` != Linux ] ; then
889     echo 1>&2 "$PRG: This utility will only work with GNU/Linux"
890     exit 1
891 fi
892
893 ## check for ppc, i think uname -m is safe for this...
894 if [ `uname -m` != ppc -a `uname -m` != ppc64 ] ; then
895     echo 1>&2 "$PRG: This utility will only work on PowerPC hardware"
896     exit 1
897 fi
898
899 ## ofpath cannot live without procfs
900 if [ ! -f /proc/uptime ] ; then
901     echo 1>&2 "$PRG: This utility requires the /proc filesystem"
902     exit 1
903 fi
904
905 ## check for retarded devfs names and tell them to foad.
906 if ckdevfs "$device" ; then
907     device="$(fixdevfs $device)" || exit 1
908 fi
909
910 ## check for newworld mac. use cat hack due to /proc wierdness.
911 if [ "$(v=`cat /proc/cpuinfo 2>/dev/null | grep pmac-generation` ; echo ${v##*:[ ]})" = NewWorld ] ; then
912     SUBARCH=NewWorld
913 elif [ "$(v=`cat /proc/cpuinfo 2>/dev/null | grep pmac-generation` ; echo ${v##*:[ ]})" = OldWorld ] ; then
914     SUBARCH=OldWorld
915 elif (cat /proc/cpuinfo 2>/dev/null | grep ^motherboard | grep -q AAPL) ; then
916     SUBARCH=OldWorld
917 elif (cat /proc/cpuinfo 2> /dev/null | grep ^machine | grep -q 'CHRP IBM') ; then
918     SUBARCH=CHRP
919 elif (cat /proc/cpuinfo 2>/dev/null | grep ^machine | grep -q 'CHRP Pegasos') ; then
920     SUBARCH=Pegasos
921 else
922     echo 1>&2 "$PRG: This machine is not yet supported"
923     exit 1
924 fi
925
926 ## make sure /proc/device-tree exists
927 if [ ! -d /proc/device-tree ] ; then
928     echo 1>&2 "$PRG: /proc/device-tree does not exist"
929     echo 1>&2 "$PRG: Make sure you compiled your kernel with CONFIG_PROC_DEVICETREE=y"
930     exit 1
931 fi
932
933 ## make sure we have what we need.
934 checkutils || exit 1
935
936 ## get the base device node and scrap /dev/ ie /dev/hda2 -> hda
937 DEVICE="${device##*/}"
938 DEVNODE="${DEVICE%%[0-9]*}"
939 PARTITION="${DEVICE##*[a-z]}"
940
941 ## use appropriate search for right sub arch.
942 case "$SUBARCH" in
943     # Pegasos OF seems to be NewWorld-ish enough to cope with this.
944     NewWorld|Pegasos)
945         newworld || exit 1
946         ;;
947     OldWorld)
948         oldworld || exit 1
949         ;;
950     CHRP)
951         chrp || exit 1
952         ;;
953 esac
954
955 exit 0